--- tarsnap-1.0.29/keygen/keygen.c	2011-01-23 23:34:37.000000000 -0800
+++ tarsnap-1.0.30/keygen/keygen.c	2011-08-11 17:17:28.000000000 -0700
@@ -127,7 +127,8 @@
 
 	/*
 	 * It doesn't make sense to specify --passphrase-mem if we're not
-	 * using a passphrase. */
+	 * using a passphrase.
+	 */
 	if ((maxmem != 0) && (passphrased == 0))
 		usage();
 
@@ -136,11 +137,20 @@
 		fprintf(stderr, "User name too long: %s\n", C.user);
 		exit(1);
 	}
+	if (strlen(C.user) == 0) {
+		fprintf(stderr, "User name must be non-empty\n");
+		exit(1);
+	}
 
+	/* Sanity-check the machine name. */
 	if (strlen(C.name) > 255) {
 		fprintf(stderr, "Machine name too long: %s\n", C.name);
 		exit(1);
 	}
+	if (strlen(C.name) == 0) {
+		fprintf(stderr, "Machine name must be non-empty\n");
+		exit(1);
+	}
 
 	/* Get a password. */
 	if (tarsnap_readpass(&C.passwd, "Enter tarsnap account password",
--- tarsnap-1.0.29/keymgmt/keymgmt.c	2011-01-22 22:50:06.000000000 -0800
+++ tarsnap-1.0.30/keymgmt/keymgmt.c	2011-05-24 16:38:40.000000000 -0700
@@ -127,7 +127,8 @@
 
 	/*
 	 * It doesn't make sense to specify --passphrase-mem if we're not
-	 * using a passphrase. */
+	 * using a passphrase.
+	 */
 	if ((maxmem != 0) && (passphrased == 0))
 		usage();
 
--- tarsnap-1.0.29/keyregen/keyregen.c	2011-02-02 03:46:11.000000000 -0800
+++ tarsnap-1.0.30/keyregen/keyregen.c	2011-05-29 21:51:29.000000000 -0700
@@ -77,7 +77,7 @@
 	uint64_t dummy;
 
 #ifdef NEED_WARN_PROGNAME
-	warn_progname = "tarsnap-keygen";
+	warn_progname = "tarsnap-rekeygen";
 #endif
 
 	/*
@@ -142,7 +142,8 @@
 
 	/*
 	 * It doesn't make sense to specify --passphrase-mem if we're not
-	 * using a passphrase. */
+	 * using a passphrase.
+	 */
 	if ((maxmem != 0) && (passphrased == 0))
 		usage();
 
@@ -151,11 +152,20 @@
 		fprintf(stderr, "User name too long: %s\n", C.user);
 		exit(1);
 	}
+	if (strlen(C.user) == 0) {
+		fprintf(stderr, "User name must be non-empty\n");
+		exit(1);
+	}
 
+	/* Sanity-check the machine name. */
 	if (strlen(C.name) > 255) {
 		fprintf(stderr, "Machine name too long: %s\n", C.name);
 		exit(1);
 	}
+	if (strlen(C.name) == 0) {
+		fprintf(stderr, "Machine name must be non-empty\n");
+		exit(1);
+	}
 
 	/* Get a password. */
 	if (tarsnap_readpass(&C.passwd, "Enter tarsnap account password",
--- tarsnap-1.0.29/lib/crypto/crypto.h	2011-01-22 22:34:00.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto.h	2011-05-29 17:45:31.000000000 -0700
@@ -85,7 +85,7 @@
 typedef struct crypto_session_internal CRYPTO_SESSION;
 
 /**
- * crypto_entropy_init():
+ * crypto_entropy_init(void):
  * Initialize the PRNG.
  */
 int crypto_entropy_init(void);
@@ -98,7 +98,7 @@
 int crypto_entropy_read(uint8_t *, size_t);
 
 /**
- * crypto_keys_init():
+ * crypto_keys_init(void):
  * Initialize the key cache.  Note that crypto_entropy_init MUST be called
  * before this function.
  */
@@ -147,7 +147,7 @@
 
 /**
  * crypto_hash_data_key_2(key, keylen, data0, len0, data1, len1, buf):
- * Hash the concatentation of two buffers with the provided HMAC-SHA256 key.
+ * Hash the concatenation of two buffers with the provided HMAC-SHA256 key.
  */
 void crypto_hash_data_key_2(const uint8_t *, size_t,
     const uint8_t *, size_t, const uint8_t *, size_t, uint8_t[32]);
@@ -237,7 +237,7 @@
 
 /**
  * crypto_session_init(pub, priv, nonce, mkey, encr_write, auth_write,
- *     encr_read, auth_read, proofs):
+ *     encr_read, auth_read):
  * Compute K = ${pub}^(2^258 + ${priv}), mkey = MGF1(nonce || K, 48), and
  * return a CRYPTO_SESSION with encryption and authentication write and read
  * keys constructed from HMAC(mkey, (encr|auth)_(write|read)).
--- tarsnap-1.0.29/lib/crypto/crypto_entropy.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_entropy.c	2011-05-29 17:45:45.000000000 -0700
@@ -154,7 +154,7 @@
 }
 
 /**
- * crypto_entropy_init():
+ * crypto_entropy_init(void):
  * Initialize the PRNG.
  */
 int
--- tarsnap-1.0.29/lib/crypto/crypto_file.c	2011-01-22 15:56:03.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_file.c	2011-05-29 17:45:55.000000000 -0700
@@ -23,7 +23,7 @@
 static int keygen(void);
 
 /**
- * crypto_file_init_keys():
+ * crypto_file_init_keys(void):
  * Initialize the keys cached by crypto_file.
  */
 int
--- tarsnap-1.0.29/lib/crypto/crypto_hash.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_hash.c	2011-07-28 21:06:38.000000000 -0700
@@ -24,7 +24,7 @@
 
 /**
  * crypto_hash_data_key_2(key, keylen, data0, len0, data1, len1, buf):
- * Hash the concatentation of two buffers with the provided HMAC-SHA256 key.
+ * Hash the concatenation of two buffers with the provided HMAC-SHA256 key.
  */
 void
 crypto_hash_data_key_2(const uint8_t * key, size_t keylen,
--- tarsnap-1.0.29/lib/crypto/crypto_internal.h	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_internal.h	2011-05-29 17:46:06.000000000 -0700
@@ -27,7 +27,7 @@
 struct crypto_hmac_key * crypto_keys_lookup_HMAC(int);
 
 /**
- * crypto_keys_server_import_root():
+ * crypto_keys_server_import_root(void):
  * Import the public part of the server root key.
  */
 int crypto_keys_server_import_root(void);
@@ -86,7 +86,7 @@
 int crypto_keys_subr_generate_HMAC(struct crypto_hmac_key **);
 
 /**
- * crypto_file_init_keys():
+ * crypto_file_init_keys(void):
  * Initialize the keys cached by crypto_file.
  */
 int crypto_file_init_keys(void);
--- tarsnap-1.0.29/lib/crypto/crypto_keys.c	2011-01-30 09:31:34.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_keys.c	2011-05-30 06:02:18.000000000 -0700
@@ -112,7 +112,7 @@
 }
 
 /**
- * crypto_keys_init():
+ * crypto_keys_init(void):
  * Initialize the key cache.
  */
 int
@@ -505,7 +505,7 @@
 		keys &= ~CRYPTO_KEYMASK_HMAC_NAME;
 	}
 
-	/* Chunkfication parameters HMAC key. */
+	/* Chunkification parameters HMAC key. */
 	if (keys & CRYPTO_KEYMASK_HMAC_CPARAMS) {
 		if (crypto_keys_subr_generate_HMAC(&keycache.hmac_cparams))
 			goto err0;
@@ -646,7 +646,7 @@
 
 /**
  * crypto_keys_lookup_HMAC(key):
- * Return the requested HMAC key
+ * Return the requested HMAC key.
  */
 struct crypto_hmac_key *
 crypto_keys_lookup_HMAC(int key)
--- tarsnap-1.0.29/lib/crypto/crypto_keys_server.c	2011-01-22 22:40:46.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_keys_server.c	2011-05-29 17:46:25.000000000 -0700
@@ -49,7 +49,7 @@
 };
 
 /**
- * crypto_keys_server_import_root():
+ * crypto_keys_server_import_root(void):
  * Import the public part of the server root key.
  */
 int
--- tarsnap-1.0.29/lib/crypto/crypto_session.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/crypto_session.c	2011-04-21 12:45:47.000000000 -0700
@@ -51,7 +51,7 @@
 	memcpy(MGFbuf + 32, K, CRYPTO_DH_PUBLEN);
 	crypto_MGF1(MGFbuf, 32 + CRYPTO_DH_PUBLEN, mkey, 48);
 
-	/* Allocate space for session key stucture. */
+	/* Allocate space for session key structure. */
 	if ((CS = malloc(sizeof(struct crypto_session_internal))) == NULL)
 		goto err0;
 
--- tarsnap-1.0.29/lib/crypto/sha256.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/crypto/sha256.c	2011-07-28 21:09:46.000000000 -0700
@@ -171,7 +171,7 @@
 	RNDr(S, W, 62, 0xbef9a3f7);
 	RNDr(S, W, 63, 0xc67178f2);
 
-	/* 4. Mix local working variables into global state */
+	/* 4. Mix local working variables into global state. */
 	for (i = 0; i < 8; i++)
 		state[i] += S[i];
 
@@ -201,12 +201,12 @@
 	 */
 	be32enc_vect(len, ctx->count, 8);
 
-	/* Add 1--64 bytes so that the resulting length is 56 mod 64 */
+	/* Add 1--64 bytes so that the resulting length is 56 mod 64. */
 	r = (ctx->count[1] >> 3) & 0x3f;
 	plen = (r < 56) ? (56 - r) : (120 - r);
 	SHA256_Update(ctx, PAD, (size_t)plen);
 
-	/* Add the terminating bit-count */
+	/* Add the terminating bit-count. */
 	SHA256_Update(ctx, len, 8);
 }
 
@@ -215,10 +215,10 @@
 SHA256_Init(SHA256_CTX * ctx)
 {
 
-	/* Zero bits processed so far */
+	/* Zero bits processed so far. */
 	ctx->count[0] = ctx->count[1] = 0;
 
-	/* Magic initialization constants */
+	/* Magic initialization constants. */
 	ctx->state[0] = 0x6A09E667;
 	ctx->state[1] = 0xBB67AE85;
 	ctx->state[2] = 0x3C6EF372;
@@ -229,7 +229,7 @@
 	ctx->state[7] = 0x5BE0CD19;
 }
 
-/* Add bytes into the hash */
+/* Add bytes into the hash. */
 void
 SHA256_Update(SHA256_CTX * ctx, const void *in, size_t len)
 {
@@ -237,38 +237,42 @@
 	uint32_t r;
 	const unsigned char *src = in;
 
-	/* Number of bytes left in the buffer from previous updates */
+	/* Return immediately if we have nothing to do. */
+	if (len == 0)
+		return;
+
+	/* Number of bytes left in the buffer from previous updates. */
 	r = (ctx->count[1] >> 3) & 0x3f;
 
-	/* Convert the length into a number of bits */
+	/* Convert the length into a number of bits. */
 	bitlen[1] = ((uint32_t)len) << 3;
 	bitlen[0] = (uint32_t)(len >> 29);
 
-	/* Update number of bits */
+	/* Update number of bits. */
 	if ((ctx->count[1] += bitlen[1]) < bitlen[1])
 		ctx->count[0]++;
 	ctx->count[0] += bitlen[0];
 
-	/* Handle the case where we don't need to perform any transforms */
+	/* Handle the case where we don't need to perform any transforms. */
 	if (len < 64 - r) {
 		memcpy(&ctx->buf[r], src, len);
 		return;
 	}
 
-	/* Finish the current block */
+	/* Finish the current block. */
 	memcpy(&ctx->buf[r], src, 64 - r);
 	SHA256_Transform(ctx->state, ctx->buf);
 	src += 64 - r;
 	len -= 64 - r;
 
-	/* Perform complete blocks */
+	/* Perform complete blocks. */
 	while (len >= 64) {
 		SHA256_Transform(ctx->state, src);
 		src += 64;
 		len -= 64;
 	}
 
-	/* Copy left over data into buffer */
+	/* Copy left over data into buffer. */
 	memcpy(ctx->buf, src, len);
 }
 
@@ -280,13 +284,13 @@
 SHA256_Final(unsigned char digest[32], SHA256_CTX * ctx)
 {
 
-	/* Add padding */
+	/* Add padding. */
 	SHA256_Pad(ctx);
 
-	/* Write the hash */
+	/* Write the hash. */
 	be32enc_vect(digest, ctx->state, 32);
 
-	/* Clear the context state */
+	/* Clear the context state. */
 	memset((void *)ctx, 0, sizeof(*ctx));
 }
 
--- tarsnap-1.0.29/lib/datastruct/patricia.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/datastruct/patricia.c	2011-05-29 17:47:14.000000000 -0700
@@ -49,7 +49,7 @@
  *
  * In some applications it may be preferable to eliminate variable-length
  * memory allocations entirely and provide the same size of memory allocation
- * to each node; if this is done, it would almost certainly be desireable to
+ * to each node; if this is done, it would almost certainly be desirable to
  * reduce MAXSLEN further, e.g., to (2 * sizeof(void *) - 3) so that each
  * node would be of size (4 * sizeof(void *)).
  */
@@ -241,7 +241,7 @@
 }
 
 /*
- * Recusively free the tree.
+ * Recursively free the tree.
  */
 static void
 free_internal(struct pnode * n)
@@ -260,7 +260,7 @@
 }
 
 /**
- * patricia_init():
+ * patricia_init(void):
  * Create a Patricia tree to be used for mapping arbitrary-length keys to
  * records.  Return NULL on failure.
  */
@@ -335,7 +335,7 @@
 			 * Split the node *np after mlen bytes and a number
 			 * of bits based on mask.  Leave *np pointing to the
 			 * upper of the two nodes (because we will continue
-			 * by traversing into the so-far-nonexistant child
+			 * by traversing into the so-far-nonexistent child
 			 * of the new node).
 			 */
 			/* Create the lower of the new nodes. */
@@ -468,7 +468,7 @@
 
 /**
  * patricia_foreach(tree, func, cookie):
- * Traverse the tree in lexographical order of stored keys, and call
+ * Traverse the tree in lexicographical order of stored keys, and call
  * func(cookie, key, keylen, rec) for each (key, record) pair.  Stop the
  * traversal early if func returns a non-zero value; return zero, the
  * non-zero value returned by func, or (-1) if an error occurs in the
@@ -507,7 +507,7 @@
 patricia_free(PATRICIA * P)
 {
 
-	/* Behave consistenly with free(NULL). */
+	/* Behave consistently with free(NULL). */
 	if (P == NULL)
 		return;
 
--- tarsnap-1.0.29/lib/datastruct/patricia.h	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/datastruct/patricia.h	2011-05-29 17:47:08.000000000 -0700
@@ -10,7 +10,7 @@
 typedef struct patricia_internal PATRICIA;
 
 /**
- * patricia_init():
+ * patricia_init(void):
  * Create a Patricia tree to be used for mapping arbitrary-length keys to
  * records.  Return NULL on failure.
  */
@@ -42,7 +42,7 @@
 
 /**
  * patricia_foreach(tree, func, cookie):
- * Traverse the tree in lexographical order of stored keys, and call
+ * Traverse the tree in lexicographical order of stored keys, and call
  * func(cookie, key, keylen, rec) for each (key, record) pair.  Stop the
  * traversal early if func returns a non-zero value; return zero, the
  * non-zero value returned by func, or (-1) if an error occurs in the
--- tarsnap-1.0.29/lib/datastruct/rwhashtab.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/datastruct/rwhashtab.c	2011-05-24 23:19:13.000000000 -0700
@@ -37,21 +37,20 @@
 };
 
 static int rwhashtab_enlarge(RWHASHTAB * H);
-static size_t rwhashtab_search(RWHASHTAB * H, void ** ht, size_t size,
-    const uint8_t * key);
+static size_t rwhashtab_search(RWHASHTAB * H, const uint8_t * key);
 
-/* Enlarge the table by a factor of 2, and rehash */
+/* Enlarge the table by a factor of 2, and rehash. */
 static int
 rwhashtab_enlarge(RWHASHTAB * H)
 {
-	void ** htnew;
+	void ** htnew, ** htold;
 	void * rec;
-	size_t newsize;
+	size_t newsize, oldsize;
 	size_t htposold, htposnew;
 
 	/*
 	 * Compute new size, and make sure the new table size in bytes
-	 * doesn't overflow
+	 * doesn't overflow.
 	 */
 	newsize = H->cursize * 2;
 	if (newsize > SIZE_MAX / sizeof(void *)) {
@@ -59,27 +58,30 @@
 		return (-1);
 	}
 
-	/* Allocate and zero the new space */
-	htnew = malloc(newsize * sizeof(void *));
-	if (htnew == NULL)
+	/* Allocate and zero the new space. */
+	if ((htnew = malloc(newsize * sizeof(void *))) == NULL)
 		return (-1);
 	for (htposnew = 0; htposnew < newsize; htposnew++)
 		htnew[htposnew] = NULL;
 
-	/* Rehash into new table */
-	for (htposold = 0; htposold < H->cursize; htposold++) {
-		rec = H->ht[htposold];
+	/* Attach new space to hash table. */
+	htold = H->ht;
+	H->ht = htnew;
+	oldsize = H->cursize;
+	H->cursize = newsize;
+
+	/* Rehash into new table. */
+	for (htposold = 0; htposold < oldsize; htposold++) {
+		rec = htold[htposold];
 		if (rec != NULL) {
-			htposnew = rwhashtab_search(H, htnew, newsize,
+			htposnew = rwhashtab_search(H,
 			    (uint8_t *)rec + H->keyoffset);
-			htnew[htposnew] = rec;
+			H->ht[htposnew] = rec;
 		}
 	}
 
-	/* Update fields in H and free now-unused memory. */
-	free(H->ht);
-	H->ht = htnew;
-	H->cursize = newsize;
+	/* Free now-unused memory. */
+	free(htold);
 
 	/* Success! */
 	return (0);
@@ -90,12 +92,12 @@
  * Return the position of the record or of the first NULL found.
  */
 static size_t
-rwhashtab_search(RWHASHTAB * H, void ** ht, size_t size, const uint8_t * key)
+rwhashtab_search(RWHASHTAB * H, const uint8_t * key)
 {
 	size_t htpos;
 	uint8_t hashbuf[32];
 
-	/* Compute the hash of the record key */
+	/* Compute the hash of the record key. */
 	if (crypto_hash_data_2(CRYPTO_KEY_HMAC_SHA256, H->randbuf, 32,
 	    key, H->keylength, hashbuf)) {
 		warn0("Programmer error: "
@@ -103,8 +105,8 @@
 		abort();
 	}
 
-	/* Compute starting hash location */
-	htpos = le64dec(hashbuf) & (size - 1);
+	/* Compute starting hash location. */
+	htpos = le64dec(hashbuf) & (H->cursize - 1);
 
 	/*
 	 * Search.  This is not an endless loop since the table isn't
@@ -112,16 +114,16 @@
 	 */
 	do {
 		/* Is the space empty? */
-		if (ht[htpos] == NULL)
+		if (H->ht[htpos] == NULL)
 			return (htpos);
 
 		/* Do we have the right key? */
-		if (memcmp((uint8_t *)(ht[htpos]) + H->keyoffset,
+		if (memcmp((uint8_t *)(H->ht[htpos]) + H->keyoffset,
 		    key, H->keylength) == 0)
 			return (htpos);
 
-		/* Move to the next table entry */
-		htpos = (htpos + 1) & (size - 1);
+		/* Move to the next table entry. */
+		htpos = (htpos + 1) & (H->cursize - 1);
 	} while (1);
 }
 
@@ -137,7 +139,7 @@
 	RWHASHTAB * H;
 	size_t i;
 
-	/* Sanity check */
+	/* Sanity check. */
 	if (keylength == 0)
 		return (NULL);
 
@@ -156,14 +158,14 @@
 		return (NULL);
 	}
 
-	/* Allocate space for pointers to records */
+	/* Allocate space for pointers to records. */
 	H->ht = malloc(H->cursize * sizeof(void *));
 	if (H->ht == NULL) {
 		free(H);
 		return (NULL);
 	}
 
-	/* All of the entries are empty */
+	/* All of the entries are empty. */
 	for (i = 0; i < H->cursize; i++)
 		H->ht[i] = NULL;
 
@@ -200,14 +202,13 @@
 	 * Search for the record, to see if it is already present and/or
 	 * where it should be inserted.
 	 */
-	htpos = rwhashtab_search(H, H->ht, H->cursize,
-	    (uint8_t *)rec + H->keyoffset);
+	htpos = rwhashtab_search(H, (uint8_t *)rec + H->keyoffset);
 
 	/* Already present? */
 	if (H->ht[htpos] != NULL)
 		return (1);
 
-	/* Insert the record */
+	/* Insert the record. */
 	H->ht[htpos] = rec;
 	H->numentries += 1;
 	return (0);
@@ -223,10 +224,10 @@
 {
 	size_t htpos;
 
-	/* Search */
-	htpos = rwhashtab_search(H, H->ht, H->cursize, key);
+	/* Search. */
+	htpos = rwhashtab_search(H, key);
 
-	/* Return the record, or NULL if not present */
+	/* Return the record, or NULL if not present. */
 	return (H->ht[htpos]);
 }
 
@@ -261,11 +262,11 @@
 rwhashtab_free(RWHASHTAB * H)
 {
 
-	/* Behave consistenly with free(NULL). */
+	/* Behave consistently with free(NULL). */
 	if (H == NULL)
 		return;
 
-	/* Free everything */
+	/* Free everything. */
 	free(H->ht);
 	free(H);
 }
--- tarsnap-1.0.29/lib/netpacket/netpacket_op.c	2011-01-30 09:41:47.000000000 -0800
+++ tarsnap-1.0.30/lib/netpacket/netpacket_op.c	2011-08-07 08:27:00.000000000 -0700
@@ -23,6 +23,9 @@
 /* Maximum number of times we'll try to reconnect. */
 #define MAXRECONNECTS	10
 
+/* As above, except the server doesn't seem to be around at all. */
+#define MAXRECONNECTS_AWOL	1
+
 /* Time to wait between each attempt. */
 static int reconnect_wait[MAXRECONNECTS + 1] = {
     0, 0, 1, 2, 4, 8, 15, 30, 60, 90, 90
@@ -235,10 +238,10 @@
 	/* We're not reading a packet any more, if we ever were. */
 	NPC->reading = 0;
 
-	/* Have we lost out connection / failed to connect too many times? */
+	/* Have we lost our connection / failed to connect too many times? */
 	NPC->ndrops += 1;
-	if ((NPC->ndrops > 10) ||
-	    (NPC->serveralive == 0 && NPC->ndrops > 1)) {
+	if ((NPC->ndrops > MAXRECONNECTS) ||
+	    (NPC->serveralive == 0 && NPC->ndrops > MAXRECONNECTS_AWOL)) {
 		warn0("Too many network failures");
 		goto err0;
 	}
@@ -502,6 +505,9 @@
 		NPC->pending_current = next;
 	}
 
+	/* Free string allocated by strdup. */
+	free(NPC->useragent);
+
 	/* Free the cookie. */
 	free(NPC);
 
@@ -516,6 +522,7 @@
 		NPC->pending_current = next;
 	}
 
+	free(NPC->useragent);
 	free(NPC);
 
 	/* Failure! */
--- tarsnap-1.0.29/lib/netproto/netproto.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/netproto/netproto.c	2011-04-21 12:48:58.000000000 -0700
@@ -155,7 +155,7 @@
 
 	/*
 	 * Our wake-up call is happening right now; record that there is no
-	 * pending callback so that we don't try to unregister it when the
+	 * pending callback so that we don't try to deregister it when the
 	 * connection is closed later.
 	 */
 	C->sleepcookie.handle = -1;
--- tarsnap-1.0.29/lib/netproto/netproto.h	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/netproto/netproto.h	2011-04-21 12:49:41.000000000 -0700
@@ -24,7 +24,7 @@
 
 /**
  * netproto_connect(useragent, callback, cookie):
- * Create a socket, connect to the tarsnap server, and perform the neccesary
+ * Create a socket, connect to the tarsnap server, and perform the necessary
  * key exchange.  Return a network protocol connection cookie; note that
  * this cookie must not be used until the callback is called.
  */
--- tarsnap-1.0.29/lib/netproto/netproto_connect.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/netproto/netproto_connect.c	2011-04-21 12:49:53.000000000 -0700
@@ -191,7 +191,7 @@
 
 /**
  * netproto_connect(useragent, callback, cookie):
- * Create a socket, connect to the tarsnap server, and perform the neccesary
+ * Create a socket, connect to the tarsnap server, and perform the necessary
  * key exchange.  Return a network protocol connection cookie; note that
  * this cookie must not be used until the callback is called.
  */
--- tarsnap-1.0.29/lib/netproto/netproto_keyexchange.c	2011-01-30 09:22:58.000000000 -0800
+++ tarsnap-1.0.30/lib/netproto/netproto_keyexchange.c	2011-04-21 12:49:19.000000000 -0700
@@ -354,7 +354,7 @@
 
 	/*-
 	 * NOTE: We could construct the session keys, and compute and send
-	 * the proof of key posession in dh_received instead of here; doing
+	 * the proof of key possession in dh_received instead of here; doing
 	 * so would reduce the bandwidth used since the two messages of 256
 	 * and 32 bytes would be coalesced into a single TCP/IP packet, but
 	 * it would slow down the connection setup since it would prevent the
--- tarsnap-1.0.29/lib/netproto/netproto_packet.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/netproto/netproto_packet.c	2011-05-24 23:20:24.000000000 -0700
@@ -90,7 +90,7 @@
 		goto err1;
 	}
 
-	/* Decrypt header in-place */
+	/* Decrypt header in-place. */
 	crypto_session_decrypt(RC->C->keys, RC->header, RC->header, 37);
 
 	/* Decode packet length. */
--- tarsnap-1.0.29/lib/network/network.h	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/network/network.h	2011-06-20 00:04:06.000000000 -0700
@@ -27,7 +27,7 @@
 #define NETWORK_STATUS_MAX	6
 
 /**
- * network_init():
+ * network_init(void):
  * Initialize the network subsystem.
  */
 int network_init(void);
@@ -106,7 +106,7 @@
     network_callback *, void *);
 
 /**
- * network_write(fd, buf, buflen, timeo, callback, cookie):
+ * network_read(fd, buf, buflen, to0, to1, callback, cookie):
  * Asynchronously write data from the provided buffer to ${fd}, and call
  * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
  * out if no data can be written for a period of time to0, or if the complete
@@ -166,7 +166,7 @@
 void network_getselectstats(double *, double *, double *, double *);
 
 /**
- * network_fini():
+ * network_fini(void):
  * Free resources associated with the network subsystem.
  */
 void network_fini(void);
--- tarsnap-1.0.29/lib/network/network_buf.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/network/network_buf.c	2011-06-20 00:04:25.000000000 -0700
@@ -260,7 +260,7 @@
 }
 
 /**
- * network_write(fd, buf, buflen, timeo, callback, cookie):
+ * network_read(fd, buf, buflen, to0, to1, callback, cookie):
  * Asynchronously write data from the provided buffer to ${fd}, and call
  * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
  * out if no data can be written for a period of time to0, or if the complete
--- tarsnap-1.0.29/lib/network/network_connect.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/network/network_connect.c	2011-04-21 12:50:09.000000000 -0700
@@ -126,7 +126,7 @@
 	 * If FreeBSD's net.inet.ip.portrange.randomized sysctl is set to 1
 	 * (the default value) FreeBSD sometimes reuses a source port faster
 	 * than might naively be expected.  This doesn't cause any problems
-	 * except if the pf filewall is running on the source system; said
+	 * except if the pf firewall is running on the source system; said
 	 * firewall detects the packet as belonging to an expired connection
 	 * and drops it.  This would be fine, except that the FreeBSD kernel
 	 * doesn't merely drop the packet when a firewall blocks an outgoing
--- tarsnap-1.0.29/lib/network/network_select.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/network/network_select.c	2011-08-14 13:15:16.000000000 -0700
@@ -91,7 +91,8 @@
 		cplen = nlen;
 	else
 		cplen = clen;
-	memcpy(nbuf, *ptr, cplen * size);
+	if (cplen > 0)
+		memcpy(nbuf, *ptr, cplen * size);
 
 	/* Zero any uninitialized buffer contents. */
 	memset((void *)((char *)nbuf + cplen * size), 0,
@@ -206,7 +207,7 @@
 }
 
 /**
- * network_init():
+ * network_init(void):
  * Initialize the network subsystem and return a cookie.
  */
 int
@@ -730,7 +731,7 @@
 }
 
 /**
- * network_fini():
+ * network_fini(void):
  * Free resources associated with the network subsystem.
  */
 void
--- tarsnap-1.0.29/lib/scryptenc/scryptenc.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/scryptenc/scryptenc.c	2011-08-07 08:21:43.000000000 -0700
@@ -317,7 +317,7 @@
 /**
  * scryptdec_buf(inbuf, inbuflen, outbuf, outlen, passwd, passwdlen,
  *     maxmem, maxmemfrac, maxtime):
- * Decrypt inbuflen bytes fro inbuf, writing the result into outbuf and the
+ * Decrypt inbuflen bytes from inbuf, writing the result into outbuf and the
  * decrypted data length to outlen.  The allocated length of outbuf must
  * be at least inbuflen.
  */
@@ -473,7 +473,7 @@
 	int rc;
 
 	/*
-	 * Read the first 7 bytes of the file; all future version of scrypt
+	 * Read the first 7 bytes of the file; all future versions of scrypt
 	 * are guaranteed to have at least 7 bytes of header.
 	 */
 	if (fread(header, 7, 1, infile) < 1) {
@@ -490,7 +490,7 @@
 		return (8);
 
 	/*
-	 * Read another 89 bytes of the file; version 0 of the srypt file
+	 * Read another 89 bytes of the file; version 0 of the scrypt file
 	 * format has a 96-byte header.
 	 */
 	if (fread(&header[7], 89, 1, infile) < 1) {
--- tarsnap-1.0.29/lib/scryptenc/scryptenc_cpuperf.c	2011-01-19 20:32:51.000000000 -0800
+++ tarsnap-1.0.30/lib/scryptenc/scryptenc_cpuperf.c	2011-08-07 08:24:39.000000000 -0700
@@ -156,7 +156,7 @@
 			break;
 	} while (1);
 
-	/* Could how many scryps we can do before the next tick. */
+	/* Count how many scrypts we can do before the next tick. */
 	if (getclocktime(&st))
 		return (2);
 	do {
--- tarsnap-1.0.29/lib/util/dirutil.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/util/dirutil.c	2011-05-24 23:16:52.000000000 -0700
@@ -74,7 +74,7 @@
 			return (-1);
 		}
 
-		/* Directory does not exist; try to create it */
+		/* Directory does not exist; try to create it. */
 		if (mkdir(dirname, 0777)) {
 			warnp("mkdir(%s)", dirname);
 			return (-1);
--- tarsnap-1.0.29/lib/util/readpass.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/util/readpass.c	2011-04-24 01:43:03.000000000 -0700
@@ -69,13 +69,13 @@
 	if ((usingtty = isatty(fileno(readfrom))) != 0) {
 		if (tcgetattr(fileno(readfrom), &term_old)) {
 			warnp("Cannot read terminal settings");
-			goto err1;
+			goto err2;
 		}
 		memcpy(&term, &term_old, sizeof(struct termios));
 		term.c_lflag = (term.c_lflag & ~ECHO) | ECHONL;
 		if (tcsetattr(fileno(readfrom), TCSANOW, &term)) {
 			warnp("Cannot set terminal settings");
-			goto err1;
+			goto err2;
 		}
 	}
 
@@ -87,7 +87,7 @@
 	/* Read the password. */
 	if (fgets(passbuf, MAXPASSLEN, readfrom) == NULL) {
 		warnp("Cannot read password");
-		goto err2;
+		goto err3;
 	}
 
 	/* Confirm the password if necessary. */
@@ -96,7 +96,7 @@
 			fprintf(stderr, "%s: ", confirmprompt);
 		if (fgets(confpassbuf, MAXPASSLEN, readfrom) == NULL) {
 			warnp("Cannot read password");
-			goto err2;
+			goto err3;
 		}
 		if (strcmp(passbuf, confpassbuf)) {
 			fprintf(stderr,
@@ -127,14 +127,18 @@
 	/* Success! */
 	return (0);
 
-err2:
+err3:
 	/* Reset terminal settings if necessary. */
 	if (usingtty)
 		tcsetattr(fileno(readfrom), TCSAFLUSH, &term_old);
-err1:
+err2:
 	/* Close /dev/tty if we opened it. */
 	if (readfrom != stdin)
 		fclose(readfrom);
+err1:
+	/* Zero any stored passwords. */
+	memset(passbuf, 0, MAXPASSLEN);
+	memset(confpassbuf, 0, MAXPASSLEN);
 
 	/* Failure! */
 	return (-1);
--- tarsnap-1.0.29/lib/util/sigquit.c	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/util/sigquit.c	2011-05-24 23:23:39.000000000 -0700
@@ -32,7 +32,7 @@
 }
 
 /**
- * termios_restore():
+ * termios_restore(void):
  * Restore the saved tc_saved termios state.
  */
 static void
@@ -72,7 +72,7 @@
 }
 
 /**
- * sigquit_init():
+ * sigquit_init(void):
  * Prepare to catch SIGQUIT and ^Q, and zero sigquit_received.
  */
 int
--- tarsnap-1.0.29/lib/util/sigquit.h	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/lib/util/sigquit.h	2011-05-24 23:24:21.000000000 -0700
@@ -7,7 +7,7 @@
 sig_atomic_t sigquit_received;
 
 /**
- * sigquit_init():
+ * sigquit_init(void):
  * Prepare to catch SIGQUIT and zero sigquit_received.
  */
 int sigquit_init(void);
--- tarsnap-1.0.29/libarchive/archive.h	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive.h	2011-05-30 06:14:50.000000000 -0700
@@ -245,7 +245,7 @@
  * will change the format code to indicate the extended format that
  * was used).  In other cases, it's because different tools have
  * modified the archive and so different parts of the archive
- * actually have slightly different formts.  (Both tar and cpio store
+ * actually have slightly different formats.  (Both tar and cpio store
  * format codes in each entry, so it is quite possible for each
  * entry to be in a different format.)
  */
@@ -492,7 +492,7 @@
 
 /*-
  * To create an archive:
- *   1) Ask archive_write_new for a archive writer object.
+ *   1) Ask archive_write_new for an archive writer object.
  *   2) Set any global properties.  In particular, you should set
  *      the compression and format to use.
  *   3) Call archive_write_open to open the file (most people
--- tarsnap-1.0.29/libarchive/archive_check_magic.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_check_magic.c	2011-05-08 13:48:23.000000000 -0700
@@ -60,7 +60,7 @@
 	/* Cause a breakpoint exception  */
 	DebugBreak();
 #endif
-	*(char *)0 = 1;	/* Deliberately segfault and force a coredump. */
+	*(volatile char *)0 = 1;	/* Deliberately segfault and force a coredump. */
 	_exit(1);	/* If that didn't work, just exit with an error. */
 }
 
--- tarsnap-1.0.29/libarchive/archive_entry.h	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_entry.h	2011-08-08 13:01:16.000000000 -0700
@@ -425,7 +425,7 @@
  *      be written.
  *   4. Call archive_entry_linkify(resolver, NULL) until
  *      no more entries are returned.
- *   5. Call archive_entry_link_resolver_free(resolver) to free resources.
+ *   5. Call archive_entry_linkresolver_free(resolver) to free resources.
  *
  * The entries returned have their hardlink and size fields updated
  * appropriately.  If an entry is passed in that does not refer to
@@ -475,7 +475,7 @@
  *           linkify(l2) => l1
  *           linkify(NULL) => l2   (at end, you retrieve remaining links)
  *    As the name suggests, this strategy is used by newer cpio variants.
- *    It's noticably more complex for the archiver, slightly more complex
+ *    It's noticeably more complex for the archiver, slightly more complex
  *    for the dearchiver than the tar strategy, but makes it straightforward
  *    to restore a file using any link by simply continuing to scan until
  *    you see a link that is stored with a body.  In contrast, the tar
